/**********************************************************************
$Id: stresstest.c,v 1.2 2002/09/08 09:25:57 bu Exp $

Copyright 2001-2002, Microbrew Software

Part of Microbrew Message Center
Multi-server Mailer Suite

http://www.microbrew.org/products/mmc/

by Bulent Yilmaz <bu@microbrew.org>
and James Brown <jim@microbrew.org>

Microbrew Message Center is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

Microbrew Message Center is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General
Public License for more details.

You should have received a copy of the GNU General Public License along with
Microbrew Message Center; if not, write to the Free Software Foundation,
Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA

**********************************************************************/

#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <time.h>

#define SERVIP "127.0.0.1"
#define SERVPORT 4001

int main() {

    int sockfd, newsockfd, clilen, childpid;
    struct sockaddr_in cli_addr, serv_addr;
    
    char senddata[32];
    int i;
    
    childpid=fork();
    
    /* Set up our connection parameters. */
    
    bzero((char *) &serv_addr, sizeof(serv_addr));
    serv_addr.sin_family = AF_INET;
    serv_addr.sin_addr.s_addr = inet_addr(SERVIP);
    serv_addr.sin_port = htons(SERVPORT);

    srand((int)time(NULL) + childpid);
    
    for(i=0; i<100; i++) {
        /* Open TCP socket. */
        
        if (( sockfd = socket(AF_INET, SOCK_STREAM, 0) ) < 0) {
            puts("Could not open socket.");
            return 1;
        }
        
        if(connect(sockfd, (struct sockaddr *) &serv_addr, sizeof(serv_addr)) < 0) {
            puts("Could not connect to server.");
            return 2;
        }
        
        snprintf(senddata, 31, "%d.%d.%d.%d\n", rand() % 256, rand() % 256, rand() % 256, rand() % 256);

        write(sockfd, senddata, strlen(senddata));
        
        close(sockfd);
        
        usleep(50);
    }

    return 0;
}
